
var oauth;

var lg = {
    consumerKey : 'extensionsforchrome',
    consumerSecret : '22fa31c6e1c42397',
    evernoteHostName : 'https://www.evernote.com',

    success: function(data) {
        var tempToken ='';
        var isCallBackConfirmed = false;
        var tokens = data.text.split("&");
        for(var i = 0 ; i < tokens.length; i++) {
            var key = tokens[i].split('=');

            if(key[0] === 'oauth_token') {
                localStorage.setItem("oauth_token", key[1]);
                tempToken = key[1];
            }
            else if(key[0] === 'oauth_token_secret') {
                localStorage.setItem("oauth_token_secret", key[1]);
            }
            else if(key[0] === 'oauth_callback_confirmed') {
                isCallBackConfirmed = true;
                localStorage['temp'] = "1";
            }
        }

        if(isCallBackConfirmed) {
            window.open(lg.evernoteHostName+'/OAuth.action?oauth_token=' + tempToken, '_blank');

        }
    },

    loginWithEvernote: function() {
        options = {
            consumerKey: lg.consumerKey,
            consumerSecret: lg.consumerSecret,
            callbackUrl : chrome.extension.getURL("images/vertical_line.png").split('images')[0]+"login.html",
            signatureMethod : "HMAC-SHA1",
        };
        oauth = OAuth(options);
        oauth.request({'method': 'GET', 'url': lg.evernoteHostName + '/oauth', 'success': lg.success, 'failure': lg.failure});
    } 
}


var clb;
var tabUrl;
function finalToken(data) {
    var tk = data.text.split("&");
    localStorage.clear();
    localStorage['token'] = decodeURIComponent(tk[0].split('=')[1]);
    localStorage['noteStoreUrl'] = decodeURIComponent(tk[5].split('=')[1]); //sa am grija sa nu mai hardcodez aici :))
    localStorage['baseURL'] = decodeURIComponent(tk[6].split('=')[1]);
   /* chrome.tabs.query({
    }, function(tabs) {
        for(var i = 0; i < tabs.length; i++) {
            if(tabs[i].url == tabUrl) {
                chrome.tabs.remove(tabs[i].id);
                break;
            }
        }
    })*/
    clb(data.text);
}

function failure(data) {
   // alert("faliure: "+JSON.stringify(data));
    console.log("failure: "+JSON.stringify(data));
}

var noteStoreURL;
var authenticationToken;
var noteStoreTransport;
var noteStoreProtocol;
var isNewNote;

var connected = false;


function saveGood() {
    var xmlhttp =new XMLHttpRequest();
    xmlhttp.onreadystatechange=function()
      {
      if (xmlhttp.status==200)
        {
           save(true);
        }
        else {
            chrome.browserAction.setBadgeBackgroundColor({color:[208, 0, 24, 255]}); 
            chrome.browserAction.setBadgeText({'text':"X"})
            console.log(xmlhttp)
        }
      }
    xmlhttp.open("GET","http://www.w3schools.com/js/default.asp",true);
    xmlhttp.send();
}


function replaceAllSubstrings(string, substring, newSubstring) {
    while(string.indexOf(substring) > -1) {
        string = string.replace(substring,newSubstring);
    }
    return string;
}

function corectBodyNote(content) {
    var cleanContent = replaceAllSubstrings(content,'<en-note>','');
    cleanContent = replaceAllSubstrings(cleanContent, '</en-note>','');
    return cleanContent;
}


function save(onlySave) {
    //chrome.extension.getBackgroundPage().alert("saving note "+ localStorage['lastOpenedNote']);
    if(isNewNote) {
        //textContent = ""+ ($('.content-wrap p').html())
        var textContent = localStorage['oldNoteContent'].replace('<!--?xml version="1.0" encoding="UTF-8"?-->', '');
        var nBody = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
         nBody += "<!DOCTYPE en-note SYSTEM \"http://xml.evernote.com/pub/enml2.dtd\">";
         nBody += "<en-note>" + corectBodyNote(textContent) + "</en-note>";
        var newNote = new Note();
        newNote.title = localStorage['oldNoteTitle'];
        newNote.content = nBody;
        newNote.contentLength = nBody.length;
        newNote.notebookGuid =localStorage['oldNoteNotebook'];

        noteStore.createNote(authenticationToken, newNote, function(nt) {
            //console.log(nt);
            if(nt && nt.guid) {
               chrome.browserAction.setBadgeBackgroundColor({color:[110, 140, 180, 255]}); 
               chrome.browserAction.setBadgeText({'text':"OK"});
               setTimeout(function() {
                    chrome.browserAction.setBadgeText({'text':""});
               }, 1000);
            }
            else {
                chrome.browserAction.setBadgeBackgroundColor({color:[208, 0, 24, 255]}); 
                chrome.browserAction.setBadgeText({'text':"x"})
            }

            if(localStorage['unsaved'] == 'true') {
                localStorage['unsaved'] = 'false';
            }
            
        })
        isNewNote = false;
    }
    else {
        
        noteStore.getNote(authenticationToken, localStorage['oldNoteGuid'], true, true, true, true, function(crtNote){
            //chrome.extension.getBackgroundPage().alert("saving note2 "+localStorage['lastOpenedNote']);

            if(crtNote && crtNote.title) {

            }else {
                chrome.browserAction.setBadgeBackgroundColor({color:[208, 0, 24, 255]}); 
                chrome.browserAction.setBadgeText({'text':"x"})
            }
            crtNote.title = localStorage['oldNoteTitle'];
            var nBody = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
             nBody += "<!DOCTYPE en-note SYSTEM \"http://xml.evernote.com/pub/enml2.dtd\">";
             nBody +="<en-note>";

            var doc = new DOMParser().parseFromString(localStorage['oldNoteContent'].replace('<en-note>','').replace('</en-note>',''), 'text/html');
            var result = new XMLSerializer().serializeToString(doc);
            result = result.replace('<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>','').replace('</body></html>','');
            result = replaceAllSubstrings(result, '<!--?xml version="1.0" encoding="UTF-8"?-->','');
            nBody += corectBodyNote(result);

             nBody +="</en-note>";
             


            crtNote.content = nBody;
            crtNote.updated = (new Date()).getTime();
            noteStore.updateNote(authenticationToken, crtNote, function(newSavedNote) {
                if(localStorage['unsaved'] == 'true') {
                    localStorage['unsaved'] = 'false';
                }
                if(newSavedNote && newSavedNote.guid) {
                   chrome.browserAction.setBadgeBackgroundColor({color:[110, 140, 180, 255]}); 
                   chrome.browserAction.setBadgeText({'text':"OK"});
                   setTimeout(function() {
                        chrome.browserAction.setBadgeText({'text':""});
                   }, 1000);
                }
                else {
                    chrome.browserAction.setBadgeBackgroundColor({color:[208, 0, 24, 255]}); 
                    chrome.browserAction.setBadgeText({'text':"x"})
                }
            })
        })  
    }

}

chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    if (request.type == "login1"){
        lg.loginWithEvernote();
    }
    else if(request.type == 'login2') {
        tabUrl = request.tabUrl;
        oauth.setVerifier(request.oauth_verifier);
        oauth.setAccessToken([request.oauth_token, localStorage['oauth_token_secret']]);
        clb = sendResponse;
        oauth.request( {
            'method': 'GET', 'url': lg.evernoteHostName + '/oauth',
               'success': finalToken, 'failure': failure
        })
    }

    if(request.type == 'badge') {
        chrome.browserAction.setBadgeText({'text':""});
        //console.log("setting badge")
    }

    if(request.type == 'saveNote') {
        //window.open(chrome.extension.getURL("images/vertical_line.png").split('images')[0]+"popup.html", "Evernote for chrome","menubar=1,resizable=1,width=820,height=564");
        if(connected == false) {
            noteStoreURL = localStorage['noteStoreUrl'];
            authenticationToken = localStorage['token'];
            noteStoreTransport = new Thrift.BinaryHttpTransport(noteStoreURL);
            noteStoreProtocol = new Thrift.BinaryProtocol(noteStoreTransport);
            noteStore = new NoteStoreClient(noteStoreProtocol);
        }
        if(localStorage['unsaved'] == 'true') {
            if(localStorage['noteIsNew'] =="true") {
                isNewNote = true;
            }
            else {
                isNewNote = false;
            }
            //save(true);
            saveGood();
        }


    }

});

//console.log(chrome.app.getDetails());
//localStorage['version'] = JSON.stringify(chrome.app.getDetails());


